<div class="field">
    <div class="name">Единица продукта</div>
    <div class="value no-shift">

        <select name="product[unit]" class="shop_zzzfractional-product-unit-select">
            {foreach $dimension->getList() as $type => $data}
            <optgroup label="{$data['name']}"></optgroup>
            {foreach $data['units'] as $unit_id => $unit_data}
            <option value="{$unit_id}" data-type="{$type}" data-unit_multiplicity="{$unit_data['unit_multiplicity']}" {if $product[shopZzzfractionalPluginConfig::ENTITY_UNIT_KEY] == $unit_id} selected{/if}>{$unit_data['name']}</option>
            {/foreach}
            {/foreach}
        </select>
    </div>
</div>
<div class="field">
    <div class="name">Кратность для покупки</div>
    <div class="value no-shift">
        <select name="product[unit_multiplicity]" class="shop_zzzfractional-product-unit_multiplicity-select">
            {foreach $dimension->getRates()  as $type => $data}
            <optgroup label="{$data['name']}"></optgroup>
            {foreach $data['units'] as  $rate}
            <option value="{$rate}"  data-type="{$type}"
                     {if isset($product['unit_multiplicity']) && $product['unit_multiplicity'] == $rate} selected{/if} class="rate-{$type}">{$rate}</option>
            {/foreach}
            {/foreach}
        </select>
    </div>
</div>
<script type="text/javascript">
    if(typeof floatval!='function') {
        function floatval(val) {
            if(val!==null && val !== undefined && val.toString().match(/,/)) {
                val = val.replace(/,/,'.');
                return parseFloat(val);
            }
            if(!isNaN(val)) {
                return parseFloat(val);
            } else {
                return 0.0;
            }
        }
    }
    $.shopZzzfractionalPluginProduct = {
        product_types: {},
        init: function(product_types) {
            this.product_types = product_types;
            $('[name="product[type_id]"]').change( function () {
                $.shopZzzfractionalPluginProduct.changeType($(this));
            });
            $('.shop_zzzfractional-product-unit-select').change(function () {
                $.shopZzzfractionalPluginProduct.changeUnit($(this));
            });
            $('.shop_zzzfractional-product-unit-select').trigger('change');
            $('.shop_zzzfractional-product-unit_multiplicity-select').trigger('change');

            var type_id =  $('[name="product[type_id]"]').val();
            if(typeof (this.product_types)=='object' && this.product_types.hasOwnProperty(type_id)) {
                var type = this.product_types[type_id];
                this.lockSelects(type);
            }
        },
        changeType: function($elem) {
            var val = $elem.val();
            if(typeof (this.product_types)=='object' && this.product_types.hasOwnProperty(val)) {
                var type = this.product_types[val];
                if(type.hasOwnProperty('unit')) {
                    $('.shop_zzzfractional-product-unit-select').val(type['unit']);
                    if(type.hasOwnProperty('unit_multiplicity')) {
                        $('.shop_zzzfractional-product-unit_multiplicity-select').val(type['unit_multiplicity']);
                    }
                    $('.shop_zzzfractional-product-unit-select').change();
                   this.lockSelects(type);
                }
            }
        },
        lockSelects: function(type) {
            if(type.hasOwnProperty('unit_lock') && type['unit_lock'] == 1) {
                this.lockUnitSelect(true);
            } else {
                this.lockUnitSelect(false);
            }
            if(type.hasOwnProperty('multiplicity_lock') && type['multiplicity_lock'] == 1) {
                this.lockUnitMultiplicitySelect(true);
            } else {
                this.lockUnitMultiplicitySelect(false);
            }
        },
        lockUnitSelect: function(state) {
            var val =  $('.shop_zzzfractional-product-unit-select').val();
            $('.shop_zzzfractional-product-unit-select').find('option').each(function () {
                if(state) {
                    if($(this).attr('value') != val) {
                        $(this).attr('disabled', state);
                       // $(this).css('display','none');
                    }
                } else {
                    $(this).attr('disabled', false);
                     // $(this).css('display','');
                }

            });
        },
        lockUnitMultiplicitySelect: function(state) {
            var val =  $('.shop_zzzfractional-product-unit_multiplicity-select').val();
            $('.shop_zzzfractional-product-unit_multiplicity-select').find('option').each(function () {
                if(state) {
                    if($(this).attr('value') != val) {
                        $(this).attr('disabled', state);
                       // $(this).css('display','none');
                    }
                } else {
                    $(this).attr('disabled', false);
                    //$(this).css('display','');
                }

            });
        },
        changeUnit: function($elem) {
            var self = $elem;
            var rateselect = $('.shop_zzzfractional-product-unit_multiplicity-select');
            if(self.find('option:selected').data('type')=='items') {
                var fractional = false;
                var val = rateselect.val();
                var selected = false;
                rateselect.find('option').each(function () {
                    /* небольшой костыль для переопределения */
                    if($(this).data('type') != 'item')  {
                        if($(this).attr('value') == val) {
                            fractional = true;
                            selected = false;
                        }
                        $(this).attr('disabled', true);
                    } else if(!selected) {
                        rateselect.val($(this).attr('value'));
                        selected = true;
                    }
                });
            } else {
                var unit_multiplicity = self.find('option:selected').data('unit_multiplicity');
                unit_multiplicity = floatval(unit_multiplicity);
                var rate = function(quantity,multiplicity) {
                    var num = quantity/multiplicity.toFixed(3);
                    num = num.toFixed(3);
                    return (num%1==0);
                };
                rateselect.find('option').each(function () {
                    if($(this).data('type') != 'item')  {
                        var val =  $(this).val();
                        val = floatval(val);
                        if(val >= unit_multiplicity && rate(val, unit_multiplicity)) {
                            $(this).attr('disabled', false);
                        } else {
                            $(this).attr('disabled', true);
                        }
                    }
                });
            }
        }
    };


    $(document).ready(function () {
        $.shopZzzfractionalPluginProduct.init({json_encode($product_types)});
    });
</script>